﻿' This is generated Code:
' Class Created by Script @ createclass.aspx
' (c) 2009-2011 Secura Hosting Ltd.  All Rights Reserved.
'
'   Clients.vb
'
'   part of WHMCSdotnet (http://whmcsdotnet.wordpress.com)
'
'   Copyright (C) 2009-2011 Mark Castle <markcastle@gmail.com>
'   All rights reserved. 
'   Copyright (C) 2009-2011 Secura Hosting Ltd <code@securahosting.com>.
'   All rights reserved.
' 
'   Redistribution and use in source and binary forms, with or without modification,
'   are permitted provided that the following conditions are met:
' 
'   - Redistributions of source code must  retain  the  above copyright notice, this
'     list of conditions and the following disclaimer.
' 
'   - Redistributions in binary form  must  reproduce the  above  copyright  notice,
'     this list of conditions  and  the  following  disclaimer in  the documentation
'     and/or other materials provided with the distribution.
' 
'   - Neither  the  name  of  Secura Hosting Ltd, Mark Castle  nor the names of  its
'     contributors may be used to endorse or  promote  products  derived  from  this
'     software without specific prior written permission.
' 
'   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
'   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT  NOT  LIMITED TO, THE IMPLIED
'   WARRANTIES  OF  MERCHANTABILITY   AND  FITNESS  FOR  A  PARTICULAR  PURPOSE  ARE
'   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
'   ANY DIRECT, INDIRECT, INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES
'   (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT  OF  SUBSTITUTE  GOODS OR SERVICES;
'   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED AND ON
'   ANY  THEORY  OF  LIABILITY,  WHETHER  IN  CONTRACT,  STRICT  LIABILITY,  OR TORT
'   (INCLUDING NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY WAY OUT OF THE USE OF THIS
'   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Option Explicit On
Option Strict On

Imports System
Imports System.Reflection
Imports System.Collections
Imports System.Diagnostics
Imports System.Xml
Imports System.Xml.Linq


Namespace Secura.WHMCS.Data

    Public Class Client


        Private Const MODULE_NAME As String = "Secura.WHMCS.Data.Client"

#Region "Properties"

        Private _Id As Integer = 0
        Private _Firstname As String = ""
        Private _Lastname As String = ""
        Private _CompanyName As String = ""
        Private _EMail As String = ""
        Private _DateCreated As DateTime = DateTime.Now()
        Private _GroupID As Integer = 0
        Private _Status As Secura.WHMCS.API.StatusTypes

        ' -----------------------------------------------
        ' -- Properties
        ' -----------------------------------------------

        ''' <summary>
        ''' Id Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property Id() As Integer
            Get
                Return _Id
            End Get

            Set(ByVal Value As Integer)
                _Id = Value
            End Set
        End Property

        ''' <summary>
        ''' Firstname Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property Firstname() As String
            Get
                Return _Firstname
            End Get

            Set(ByVal Value As String)
                _Firstname = Value
            End Set
        End Property

        ''' <summary>
        ''' Lastname Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property Lastname() As String
            Get
                Return _Lastname
            End Get

            Set(ByVal Value As String)
                _Lastname = Value
            End Set
        End Property

        ''' <summary>
        ''' CompanyName Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property CompanyName() As String
            Get
                Return _CompanyName
            End Get

            Set(ByVal Value As String)
                _CompanyName = Value
            End Set
        End Property

        ''' <summary>
        ''' EMail Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property EMail() As String
            Get
                Return _EMail
            End Get

            Set(ByVal Value As String)
                _EMail = Value
            End Set
        End Property

        ''' <summary>
        ''' DateCreated Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property DateCreated() As DateTime
            Get
                Return _DateCreated
            End Get

            Set(ByVal Value As DateTime)
                _DateCreated = Value
            End Set
        End Property

        ''' <summary>
        ''' GroupID Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property GroupID() As Integer
            Get
                Return _GroupID
            End Get

            Set(ByVal Value As Integer)
                _GroupID = Value
            End Set
        End Property

        ''' <summary>
        ''' Status Property (r/w)
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property Status() As Secura.WHMCS.API.StatusTypes
            Get
                Return _Status
            End Get

            Set(ByVal Value As Secura.WHMCS.API.StatusTypes)
                _Status = Value
            End Set
        End Property

#End Region

#Region "Public Methods"

        ' -----------------------------------------------
        ' -- Public Methods
        ' -----------------------------------------------

        ' -----------------------------------------------
        ' -- Save
        ' -----------------------------------------------
        Public Function Save() As Boolean
            ' To Be Completed

        End Function




#End Region

#Region "Constructors"

        ' -----------------------------------------------
        ' -- Constructor
        ' -----------------------------------------------	

        ''' <summary>
        ''' New Constructor
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub New()
        End Sub

        Public Sub New(ByVal Id As Integer, ByVal Firstname As String, ByVal Lastname As String, ByVal CompanyName As String, ByVal EMail As String, ByVal DateCreated As DateTime, ByVal GroupID As Integer, ByVal Status As Secura.WHMCS.API.StatusTypes)
            _Id = Id
            _Firstname = Firstname
            _Lastname = Lastname
            _CompanyName = CompanyName
            _EMail = EMail
            _DateCreated = DateCreated
            _GroupID = GroupID
            _Status = Status
        End Sub

#End Region

#Region "Private Methods"

        ' -----------------------------------------------
        ' -- Private Methods
        ' -----------------------------------------------
        ' Your Private Methods Go Here.

#End Region

#Region "Supporting Objects"

        ''' <summary>
        ''' Some Utilities used by these classes
        ''' </summary>
        ''' <remarks></remarks>
        Public Class Utilities

            ''' <summary>
            ''' CheckNull Method
            ''' If Item is Nothing then Returns Nothing rather than DbNull
            ''' </summary>
            ''' <param name="Item"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
            Public Shared Function CheckNull(ByVal Item As Object) As Object
                If Item Is System.DBNull.Value Then
                    Return Nothing
                Else
                    Return Item
                End If
            End Function

            ''' <summary>
            ''' CStrEx Method
            ''' A CStr function that doesn't cause an exception when a DBNull is encountered
            ''' </summary>
            ''' <param name="test"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
            Public Shared Function CStrEx(ByVal test As Object) As String
                If IsDBNull(test) Then
                    Return ("")
                Else
                    Return CStr(test)
                End If
            End Function

            ''' <summary>
            ''' CBoolEx Method
            ''' A CBool function that doesn't cause an exception when a DBNull is encountered
            ''' </summary>
            ''' <param name="test"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
            Public Shared Function CBoolEx(ByVal test As Object) As Boolean
                If IsDBNull(test) Then
                    Return False
                Else
                    Return CBool(test)
                End If
            End Function

            ''' <summary>
            ''' CIntEx Method
            ''' A CInt function that doesn't cause an exception when a DBNull is encountered
            ''' </summary>
            ''' <param name="test"></param>
            ''' <returns></returns>
            ''' <remarks></remarks>
            Public Shared Function CIntEx(ByVal test As Object) As Integer
                If IsDBNull(test) Then
                    Return 0
                Else
                    Return CInt(test)
                End If
            End Function

        End Class


        ''' <summary>
        ''' A Local debugging object
        ''' </summary>
        ''' <remarks></remarks>
        Class Debug

            Public Enum LogLevel As Integer
                NoLogging = 0
                Normal = 1
                Verbose = 2
                Debug = 3
            End Enum

            ''' <summary>
            ''' A Simple Logging Method
            ''' </summary>
            ''' <param name="Text"></param>
            ''' <param name="Logtype"></param>
            ''' <param name="Level"></param>
            ''' <param name="Success"></param>
            ''' <param name="WriteToEventLog"></param>
            ''' <param name="Filename"></param>
            ''' <param name="WriteToConsole"></param>
            ''' <param name="IncludePrefix"></param>
            ''' <param name="IncludeTime"></param>
            ''' <remarks></remarks>
            Public Shared Sub Log(ByVal Text As String, _
                                      Optional ByVal Logtype As EventLogEntryType = EventLogEntryType.Information, _
                                      Optional ByVal Level As LogLevel = LogLevel.Normal, _
                                      Optional ByVal Success As Boolean = True, _
                                      Optional ByVal WriteToEventLog As Boolean = True, _
                                      Optional ByVal Filename As String = "", _
                                      Optional ByVal WriteToConsole As Boolean = False, _
                                      Optional ByVal IncludePrefix As Boolean = True, _
                                      Optional ByVal IncludeTime As Boolean = True)

                ' Secura.Debug.Log(Text, Logtype, CType(Level, Secura.Client.Debug.LogLevel), Success, WriteToEventLog, Filename, WriteToConsole, IncludePrefix, IncludeTime)
                Trace.Write(LogType.ToString() & ": " & Text, "Secura.WHMCS.Data.Client")

            End Sub

        End Class
#End Region

    End Class

#Region "Collection"

    Public Class Clients
        Inherits Secura.WHMCS.Data.CollectionHelpers.ClientBase.SortableCollectionBase

        Private _xDoc As XDocument

        Public Sub New()
            MyBase.SortObjectType = GetType(Client)
        End Sub

        Sub New(ByVal XDoc As XDocument)
            ' TODO: Complete member initialization 
            _xDoc = XDoc
            If _xDoc.<whmcsapi>.<clients>(0).Elements().Count() < 1 Then
                Exit Sub
            End If

            For Each Result In _xDoc...<clients>

                Dim Item As New Client
                Item.Id = CInt(Result...<id>.Value().ToString())
                Item.Firstname = Result...<firstname>.Value.ToString()
                Item.Lastname = Result...<lastname>.Value.ToString()
                Item.EMail = Result...<email>.Value.ToString()
                Item.CompanyName = Result...<companyname>.Value.ToString()
                Item.DateCreated = CDate(Result...<datecreated>.Value.ToString())
                Item.GroupID = CInt(Result...<groupid>.Value.ToString())
                ' Item.Status = GetStatus(Result...<status>.Value.ToString())
                Item.Status = CType(System.Enum.Parse(GetType(Secura.WHMCS.API.StatusTypes), Result...<status>.Value.ToString()), Secura.WHMCS.API.StatusTypes)

                MyBase.List.Add(Item)
            Next

        End Sub

        Private Function GetStatus(ByVal Status As String) As Secura.WHMCS.API.StatusTypes
            Select Case Status.ToLower()
                Case "active"
                    Return API.StatusTypes.Active
                Case "inactive"
                    Return API.StatusTypes.Inactive
                Case "closed"
                    Return API.StatusTypes.Closed
                Case Else
                    Return API.StatusTypes.Closed
            End Select
        End Function

        ' ------------------------------------------------------------------------
        ' -- Property: Count
        ' -- Gets the number of elements contained in the Collection instance.
        ' -- This property is inherited from CollectionBase and available by default.
        ' ------------------------------------------------------------------------	

        ' ------------------------------------------------------------------------
        ' -- Property: Item
        ' -- Gets or sets the element at the specified index.
        ' ------------------------------------------------------------------------
        Default Public Property Item(ByVal Index As Integer) As Client
            Get
                Return CType(MyBase.List.Item(Index), Client)
            End Get
            Set(ByVal Value As Client)
                MyBase.List.Item(Index) = Value
            End Set
        End Property

        ' ------------------------------------------------------------------------
        ' -- Method: Clear
        ' -- Removes all objects from the CollectionBase instance
        ' -- This Method is inherited from CollectionBase and is available by default.
        ' ------------------------------------------------------------------------	
        'Public Function Clear() As Integer
        '	MyBase.List.Clear
        'End Function


        ' ------------------------------------------------------------------------
        ' -- Method: Add
        ' -- Searches Adds an object to the end of the Collection. 
        ' ------------------------------------------------------------------------	
        Public Function Add(ByVal Item As Client) As Integer
            Return MyBase.List.Add(Item)
        End Function

        ' ------------------------------------------------------------------------
        ' -- Method: IndexOf
        ' -- Searches for the specified Object and returns the zero-based index of 
        ' -- the first occurrence within the entire Collection.
        ' ------------------------------------------------------------------------
        Public Function IndexOf(ByVal Item As Client) As Integer
            Return MyBase.List.IndexOf(Item)
        End Function 'IndexOf

        ' ------------------------------------------------------------------------
        ' -- Method: Insert
        ' -- Inserts an element into the CollectionBase at the specified index. 
        ' ------------------------------------------------------------------------	
        Public Sub Insert(ByVal Index As Integer, ByVal Item As Client)
            MyBase.List.Insert(Index, Item)
        End Sub 'Insert

        ' ------------------------------------------------------------------------
        ' -- Method: Remove
        ' -- Removes the first occurrence of a specific object from the Collection. 
        ' ------------------------------------------------------------------------	
        Public Sub Remove(ByVal Item As Client)
            MyBase.List.Remove(Item)
        End Sub 'Remove

        ' ------------------------------------------------------------------------
        ' -- Method: RemoveAt
        ' -- Removes the first occurrence of a specific object from the Collection. 
        ' ------------------------------------------------------------------------	
        'Public Sub Remove(ByVal Item As Client)
        '	MyBase.List.Remove(Item)
        'End Sub 'Remove

        ' ------------------------------------------------------------------------
        ' -- Method: Contains
        ' -- Determines whether the CollectionBase contains a specific element. 
        ' ------------------------------------------------------------------------
        Public Function Contains(ByVal Item As Client) As Boolean
            ' If value is not of type Client, this will return false.
            Return MyBase.List.Contains(Item)
        End Function 'Contains

    End Class

#End Region

End Namespace

Namespace Secura.WHMCS.Data.CollectionHelpers.ClientBase

#Region " ** Interface Definitions ** "
    Public Interface IGenericComparer
        Inherits IComparer

        'IGeneriComparer Extends IComparer to include ObjectType,
        'SortByName, And SortingOrder Properties

        Property SortObjectType() As System.Type
        Property SortByName() As String
        Property SortDirection() As Integer
    End Interface

    Public Interface ISortable
        'A new interface for the abstract implementation that
        'includes our Sort method

        Property SortObjectType() As System.Type
        Property SortByName() As String
        Property SortDirection() As GenericComparer.SorterDirection

        Sub Sort()
    End Interface
#End Region

    '-----------------------------------------
    '----- Generic Comparer Class
    '----- This Class Implements the IGenericComparer interface
    '-----------------------------------------
#Region " ** GenericComparer Class ** "
    Public NotInheritable Class GenericComparer 'Sealed class
        Implements IGenericComparer

        Public Enum SorterDirection
            Ascending = 0
            Descending = 1
        End Enum

        Private m_SortObjectType As System.Type
        Private m_SortByName As String = ""
        Private m_SortDirection As Integer = 0

        Property SortObjectType() As System.Type Implements IGenericComparer.SortObjectType
            Get
                Return m_SortObjectType
            End Get
            Set(ByVal value As System.Type)
                m_SortObjectType = value
            End Set
        End Property

        Property SortByName() As String Implements IGenericComparer.SortByName
            Get
                Return m_SortByName
            End Get
            Set(ByVal value As String)
                m_SortByName = value
            End Set
        End Property

        Property SortDirection() As Integer Implements IGenericComparer.SortDirection
            Get
                Return m_SortDirection
            End Get
            Set(ByVal value As Integer)
                m_SortDirection = value
            End Set
        End Property

        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            'Basedon the property name we have to get the property info
            Dim oPropertyInfo As PropertyInfo = SortObjectType.GetProperty(m_SortByName)

            'Nowthat we have the property Info we can get the value of each of theproperties
            'castas IComparable objects
            Dim object1 As IComparable = DirectCast(oPropertyInfo.GetValue(x, Nothing), IComparable)
            Dim object2 As IComparable = DirectCast(oPropertyInfo.GetValue(y, Nothing), IComparable)

            'Nowall we have to do is compare the properties with the CompareTo method
            'Inheritedfrom IComparable
            If SortDirection = 0 Then
                Return (object1.CompareTo(object2))
            Else
                Return (object2.CompareTo(object1))
            End If
        End Function

    End Class
#End Region

    '-----------------------------------------
    '----- Abstract Implementation Class -----
    '-----------------------------------------
#Region " ** SortableCollectionBase Class** "
    Public MustInherit Class SortableCollectionBase
        Inherits Collections.CollectionBase
        Implements ISortable

        'Thisclass must be inherited and is our new Collection Class inheritedfrom
        'CollectionBaseand implementing our ISortable interface

        Private m_SortByName As String = ""
        Private m_SortDirection As GenericComparer.SorterDirection
        Private m_SortObjectType As System.Type

        Public Property SortByName() As String Implements ISortable.SortByName
            Get
                Return m_SortByName
            End Get
            Set(ByVal value As String)
                m_SortByName = value
            End Set
        End Property

        Public Property SortDirection() As GenericComparer.SorterDirection Implements ISortable.SortDirection
            Get
                Return m_SortDirection
            End Get
            Set(ByVal value As GenericComparer.SorterDirection)
                m_SortDirection = value
            End Set
        End Property

        Public Property SortObjectType() As System.Type Implements ISortable.SortObjectType
            Get
                Return m_SortObjectType
            End Get
            Set(ByVal value As System.Type)
                m_SortObjectType = value
            End Set
        End Property

        Overridable Sub Sort() Implements ISortable.Sort
            If m_SortByName = "" Then Throw New Exception("First Set SortByName")
            If m_SortObjectType Is Nothing Then Throw New Exception("First Set theSortObjectType")

            Dim oSorter As IGenericComparer = New GenericComparer()
            oSorter.SortObjectType = m_SortObjectType
            oSorter.SortByName = m_SortByName
            oSorter.SortDirection = CInt(m_SortDirection)

            InnerList.Sort(oSorter)
        End Sub

    End Class
#End Region

End Namespace